<?php
/***************************************************** 
 * CMSimple AddOn to the Plugin Privacy_XH
 *****************************************************
 *  Plugin name : no_cookies_text
 *	written by : Karl Richard Lembach, © 2021, http://cmsimple.lembach-kr.de/
 *  File name : index.php
******************************************************/
// Ergänzung zum Plugin Privacy_XH
// Ausgabe von Text abhängig davon, ob Cookies zugelassen sind oder nicht in Privacy_XH.
// Der Aufruf der Funktion im Artikeltext erfolgt wie jeder Funktionsaufruf:
// {{{no_cookies_text('Text wenn Cookies abgelehnt sind', 'Text bei Cookie setzen erlaubt')}}}
// Vorsicht mit einfachen Anführungszeichen! (') Sind solche im auszugebenden Text führt das zu einem
// schwerwiegenden Fehler, weil der PHP-Code zerstört wird.
// Wenn man ' unbedingt benötigt, dann mit Maskierung angeben: \'
// Das scheint in den Tests zu funktionieren.
// Formatierungen, die per STYLE-Argumente erzeugt werden, enthalten möglicherweise einfache Anführungszeichen!
// Unbedingt vermeiden!
// Wenn eine Formatierung notwendig ist, bei der nicht bekannt ist ob sie KEINE einfachen Anführungszeichen enthält,
// dann unbedingt über den gesamten Funktionsaufruf hinweg.
// Also so, dass alle Angaben zur Formatierung außerhalb des Funktionsaufrufes liegen.
// D.h. entweder vor den drei öffnenden geschweiften Klammern {{{ oder nach den schließenden geschweiften Klammern }}}.
//
// Addition to Privacy_XH plugin
// Output text depending on whether cookies are allowed or not in Privacy_XH.
// Calling the function in the article text is done like any function call:
// {{no_cookies_text('text if cookies are rejected', 'text if cookie set allowed')}}
// Be careful with single quotes! (') If such are in the text to be output, this will lead to a
// serious error, because the PHP code will be destroyed.
// If you absolutely need ', then specify with masking: \'
// This seems to work in the tests.
// Formatting generated by STYLE arguments may contain single quotes!
// Avoid at all costs!
// If a formatting is necessary, where it is not known if it does NOT contain single quotes,
// then absolutely over the entire function call.
// So that all information about the formatting is outside of the function call.
// I.e. either before the three opening braces {{{ or after the closing braces }}}.

/* 
 * Usage : {{{no_cookies_text($string_no_cookies , $string_cookies_allowed)}}}
 * Example : {{{no_cookies_text('Bitte erlauben Sie das Setzen von Cookies','Cookies akzeptiert')}}}
*/

/*
 * Prevent direct access.
 */
if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}

function no_cookies_text($string_no, $yes_string)
{

if (!privacy_agreed())
{
return $string_no;
}
else
{
return $yes_string;
}

}

?>